package com.zanxiang.game.back.serve.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.game.back.serve.dao.mapper.GameTencentMiniGameOrderSplitLogMapper;
import com.zanxiang.game.back.serve.pojo.entity.GameTencentMiniGameOrderSplitLog;
import com.zanxiang.game.back.serve.pojo.vo.GameTencentMiniOrderSplitLogVO;
import com.zanxiang.game.back.serve.service.IGameTencentMiniGameOrderSplitLogService;
import com.zanxiang.module.util.NumberUtil;
import com.zanxiang.module.util.bean.BeanUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class GameTencentMiniGameOrderSplitLogServiceImpl extends ServiceImpl<GameTencentMiniGameOrderSplitLogMapper, GameTencentMiniGameOrderSplitLog>
        implements IGameTencentMiniGameOrderSplitLogService {

    @Override
    public List<GameTencentMiniOrderSplitLogVO> listByOrderNo(Collection<String> orderNos) {
        if (CollectionUtils.isEmpty(orderNos)) {
            return Collections.emptyList();
        }
        return list(new LambdaQueryWrapper<GameTencentMiniGameOrderSplitLog>()
                .in(GameTencentMiniGameOrderSplitLog::getOrderNo, orderNos)
                .orderByAsc(GameTencentMiniGameOrderSplitLog::getBackIndex)
        ).stream().map(this::toVOSimple).collect(Collectors.toList());
    }

    private GameTencentMiniOrderSplitLogVO toVOSimple(GameTencentMiniGameOrderSplitLog log) {
        if (log == null) {
            return null;
        }
        GameTencentMiniOrderSplitLogVO vo = BeanUtil.copy(log, GameTencentMiniOrderSplitLogVO.class);
        if (log.getSplitMoney() != null) {
            vo.setSplitMoney(NumberUtil.divide100(new BigDecimal(log.getSplitMoney())));
        }
        return vo;
    }
}
